//  insert header/copyright here

#ifndef _Srcstream_h
#define _Srcstream_h
#pragma interface

#include <iostream.h>

//
//  Class name  : Srcstream.h
//  Description : A wrapper for ostream, with indentation and line number
//      control.
//
class srcstream  {
public:
  srcstream(ostream &o, unsigned long line=1UL);

  srcstream &ToLine(unsigned long line, bool space = true);
  srcstream &ToLineF(unsigned long line, bool space = true);
  srcstream &ToLineBefore(unsigned long line, 
			  unsigned long before,
			  bool space = true);
  srcstream &Next();

  srcstream &PushIndent(int n);  
  srcstream &PopIndent(int n) { return PushIndent(-n); };

  ostream &out()       { return *ostr; }
  unsigned long line() { return fLineNumber; }
  
  static srcstream& GetNullStream();

private:
  unsigned long fLineNumber;
  unsigned fIndentation;
  ostream *ostr;

  static srcstream* nullStream;
};

#endif // _Srcstream_H

