// find_leaks.h
//
// If FIND_LEAKS is defined, defines a reference-counter to selected pointers.

//#include <dmalloc.h>

#ifndef FIND_LEAKS

#define REF_PTR(p)
#define UNREF_PTR(p)
#define IGNORE_PTR(p)
#define MEMTRACE()

#else // FIND_LEAKS

#define REF_PTR(p)    ::register_pointer(p, __FILE__, __LINE__)
#define UNREF_PTR(p)  ::unregister_pointer(p)
#define IGNORE_PTR(p) ::ignore_pointer(p)
#define MEMTRACE()    ::memory_trace()

void register_pointer(const void *p, const char *file, unsigned long line);
void unregister_pointer(const void *p);
void ignore_pointer(const void *p);
void memory_trace();

#endif





